function ber = ber_estim_qpsk_ble(r,equalizer,bit1,bit2)

% Prepared and maintained by L. Rugini and P. Banelli
% for E-Reference Signal Processing, published by Elsevier
%
% Copyright 2012

soft_estimate = equalizer * r;        
bit1_estimate = round((sign(real(soft_estimate))+1)/2);                  
bit2_estimate = round((sign(imag(soft_estimate))+1)/2);    
ber           = mean(0.5*(mean(bit1~=bit1_estimate,2)+mean(bit2~=bit2_estimate,2)));

% References
%
% [1] P. Banelli and L. Rugini, OFDM and Multicarrier Signal Processing,
%     E-Reference Signal Processing, Elsevier, to be published in 2013.
% 
% [2] L. Rugini, P. Banelli, and G. Leus, Low-complexity banded equalizers
%     for OFDM systems in Doppler spread channels, EURASIP J. Appl. Signal
%     Processing, vol. 2006, Article ID 67404, pp. 1-13, 2006.
