function z = ltv_channel_gen(f_d,size_t,M,L,pdp)

% Prepared and maintained by L. Rugini and P. Banelli
% for E-Reference Signal Processing, published by Elsevier
%
% Copyright 2012

t = 0:(size_t-1);
omega_d = 2*pi*f_d;
z = zeros(L,size_t);

for count = 1:L,
    
    phi = 2*pi*rand(1,1);
    psi = 2*pi*rand(M,1);
    alpha = (2*pi*((1:M).') -pi + 2*pi*rand(M,1))/(4*M);    
    
    z(count,1:size_t) = sqrt(pdp(count)/2)*2/sqrt(M)*sum( repmat(cos(psi),1,size_t).*cos(omega_d*repmat(t,M,1).*repmat(cos(alpha),1,size_t)+repmat(phi,M,size_t) ),1) + ...
               sqrt(-1)*sqrt(pdp(count)/2)*2/sqrt(M)*sum( repmat(sin(psi),1,size_t).*cos(omega_d*repmat(t,M,1).*repmat(sin(alpha),1,size_t)+repmat(phi,M,size_t) ),1);
           
end

% References
%
% [1] P. Banelli and L. Rugini, OFDM and Multicarrier Signal Processing,
%     E-Reference Signal Processing, Elsevier, to be published in 2013.
% 
% [2] Y. R. Zheng and C. Xiao, Simulation models with correct statistical
%     properties for Rayleigh fading channels, IEEE Trans. Commun.,
%     vol. 51, no. 6, pp. 920-928, June 2003.
